# Generated by Django 2.0.5 on 2020-03-12 08:28

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [("document", "0038_auto_20200312_0711")]

    def add_new_fields_to_docs_and_templates(apps, schema_editor):
        """
        Add default values for project management and terms to existing documents and templates
        """
        project_management_default = """
Project management is included with this project to ensure communication, delivery, and customer satisfaction. Project management includes the following:
 * Project kick off
 * Planning
 * Project status meetings
 * Issue Resolution
 * Project communications
 * Ensure delivery of project documentation
   
**Change Management**
            
It may become necessary to amend this Statement of Work for reasons including, but not limited to the following:
  * Changes to the project schedule or scope
  * Environmental or architectural impediments not previously identified
  * Lack of access to personnel or facilities necessary to complete project
  
In the event it is necessary to change this Statement of Work, the process outlined below will be followed
            and additional work will not be included with this statement of work until the change request is approved
            and signed by the client.
   * A change request will be created to communicate the change and any associated cost where applicable
   * The change request will describe the change, the reasons for the change, and the effect the change will have on the project
        """
        project_management_default_html = """
        <p>Project management is included with this project to ensure communication, delivery, and customer satisfaction. Project management includes the following:</p>
        <ul>
        <li>Project kick off</li>
        <li>Planning</li>
        <li>Project status meetings</li>
        <li>Issue Resolution</li>
        <li>Project communications</li>
        <li>Ensure delivery of project documentation</li>
        </ul>
        <p><strong>Change Management</strong></p>
        <p>It may become necessary to amend this Statement of Work for reasons including, but not limited to the following:</p>
        <ul>
        <li>Changes to the project schedule or scope</li>
        <li>Environmental or architectural impediments not previously identified</li>
        <li>Lack of access to personnel or facilities necessary to complete project</li>
        </ul>
        <p>In the event it is necessary to change this Statement of Work, the process outlined below will be followed
                    and additional work will not be included with this statement of work until the change request is approved
                    and signed by the client.</p>
        <ul>
        <li>A change request will be created to communicate the change and any associated cost where applicable</li>
        <li>The change request will describe the change, the reasons for the change, and the effect the change will have on the project</li>
        </ul
        """
        t_and_m_terms_default = """
* Weekly billing of actual hours based on rates section.
* All invoices are due within 30 days.
* 2-hour minimum for remote work.
* 8-hour minimum onsite per scheduled engineer engagement.
* Service hours below are estimated and do not constitute a not to exceed.
* Any Travel time and expenses will be billed to Customer. This includes but not limited to: Accommodations, Flights, Transportation, and Meals.
* Scheduling changes or service cancellations with less than 48 hour notice are subject to a 4 hour minimum bill.
* When scope is expanded, resources are subject to availability.
* This engagement is entered into on the specified date below by LookingPoint and Tanium pursuant to the terms of the Master Services Agreement which is herein incorporated by this reference. In the event of a conflict between any terms of the Master Services Agreement and terms of this document, the applicable terms of this document shall control.
            """
        t_and_m_terms_default_html = """
        <ul>
        <li>Weekly billing of actual hours based on rates section.</li>
        <li>All invoices are due within 30 days.</li>
        <li>2-hour minimum for remote work.</li>
        <li>8-hour minimum onsite per scheduled engineer engagement.</li>
        <li>Service hours below are estimated and do not constitute a not to exceed.</li>
        <li>Any Travel time and expenses will be billed to Customer. This includes but not limited to: Accommodations, Flights, Transportation, and Meals.</li>
        <li>Scheduling changes or service cancellations with less than 48 hour notice are subject to a 4 hour minimum bill.</li>
        <li>When scope is expanded, resources are subject to availability.</li>
        <li>This engagement is entered into on the specified date below by LookingPoint and Tanium pursuant to the terms of the Master Services Agreement which is herein incorporated by this reference. In the event of a conflict between any terms of the Master Services Agreement and terms of this document, the applicable terms of this document shall control.</li>
        </ul>
        """
        fixed_fee_terms_default = """
It may become necessary to amend this Statement of Work for reasons including, but not limited to the following:
  * All invoices are due within 30 days.
   * Upon receiving signed Purchase Order 50% will be billed.
   * Upon completion of this project the remaining 50% will be billed.
  * Anything not detailed in the "Project Description" is deemed out of scope.
  * Any Onsite services need to be scheduled with the LookingPoint Project Manager that will be assigned to this Statement of Work (SoW).
  * Changes to an agreed schedule are subject to the change management which may increase cost.
  * Travel will be billed on actuals which includes Accommodations, Flights, Transportation, and Meals.
  * This project is entered into on the specified date below by LookingPoint and Edmonds School District pursuant to the terms of the Master Services Agreement which is herein incorporated by this reference. In the event of a conflict between any terms of the Master Services Agreement and terms of this Statement of Work (SoW), the applicable terms of this SoW shall control.
            """
        fixed_fee_terms_default_html = """
        <p>It may become necessary to amend this Statement of Work for reasons including, but not limited to the following:</p>
        <ul>
        <li>All invoices are due within 30 days.</li>
        <li>Upon receiving signed Purchase Order 50% will be billed.</li>
        <li>Upon completion of this project the remaining 50% will be billed.</li>
        <li>Anything not detailed in the &quot;Project Description&quot; is deemed out of scope.</li>
        <li>Any Onsite services need to be scheduled with the LookingPoint Project Manager that will be assigned to this Statement of Work (SoW).</li>
        <li>Changes to an agreed schedule are subject to the change management which may increase cost.</li>
        <li>Travel will be billed on actuals which includes Accommodations, Flights, Transportation, and Meals.</li>
        <li>This project is entered into on the specified date below by LookingPoint and Edmonds School District pursuant to the terms of the Master Services Agreement which is herein incorporated by this reference. In the event of a conflict between any terms of the Master Services Agreement and terms of this Statement of Work (SoW), the applicable terms of this SoW shall control.</li>
        </ul>
        """

        new_fields_docs = {
            "project_management_fixed_fee": {
                "section_label": "Project Management Fixed Fee",
                "ordering": 4,
                "visible_in": ["Fixed Fee"],
                "default_hidden": True,
                "project_management": {
                    "section_label": "Project Management Section",
                    "ordering": 4,
                    "label": "Project Management",
                    "value_markdown": project_management_default,
                    "value": project_management_default_html,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
            "project_management_t_and_m": {
                "section_label": "Project Management T & M",
                "ordering": 5,
                "visible_in": ["T & M"],
                "default_hidden": True,
                "project_management": {
                    "section_label": "Project Management Section",
                    "ordering": 5,
                    "label": "Project Management",
                    "value_markdown": project_management_default,
                    "value": project_management_default_html,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
            "terms_fixed_fee": {
                "section_label": "Terms Fixed Fee",
                "ordering": 6,
                "visible_in": ["Fixed Fee"],
                "default_hidden": True,
                "terms": {
                    "section_label": "Terms Section",
                    "ordering": 6,
                    "label": "Terms",
                    "value_markdown": fixed_fee_terms_default,
                    "value": fixed_fee_terms_default_html,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
            "terms_t_and_m": {
                "section_label": "Terms T & M",
                "ordering": 7,
                "visible_in": ["T & M"],
                "default_hidden": True,
                "terms": {
                    "section_label": "Terms Section",
                    "ordering": 7,
                    "label": "Terms",
                    "value_markdown": t_and_m_terms_default,
                    "value": t_and_m_terms_default_html,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
        }
        new_fields_templates = {
            "project_management_fixed_fee": {
                "section_label": "Project Management Fixed Fee",
                "ordering": 4,
                "visible_in": ["Fixed Fee"],
                "default_hidden": True,
                "project_management": {
                    "section_label": "Project Management Section",
                    "ordering": 4,
                    "label": "Project Management",
                    "value": project_management_default,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
            "project_management_t_and_m": {
                "section_label": "Project Management T & M",
                "ordering": 5,
                "visible_in": ["T & M"],
                "default_hidden": True,
                "project_management": {
                    "section_label": "Project Management Section",
                    "ordering": 5,
                    "label": "Project Management",
                    "value": project_management_default,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
            "terms_fixed_fee": {
                "section_label": "Terms Fixed Fee",
                "ordering": 6,
                "visible_in": ["Fixed Fee"],
                "default_hidden": True,
                "terms": {
                    "section_label": "Terms Section",
                    "ordering": 6,
                    "label": "Terms",
                    "value": fixed_fee_terms_default,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
            "terms_t_and_m": {
                "section_label": "Terms T & M",
                "ordering": 7,
                "visible_in": ["T & M"],
                "default_hidden": True,
                "terms": {
                    "section_label": "Terms Section",
                    "ordering": 7,
                    "label": "Terms",
                    "value": t_and_m_terms_default,
                    "type": "MARKDOWN",
                    "input_type": "STRING",
                    "is_required": "true",
                    "is_label_editable": "true",
                    "reset": True,
                },
            },
        }
        SOWDocument = apps.get_model("document", "SOWDocument")
        for doc in SOWDocument.objects.all():
            doc.json_config.update(new_fields_docs)
            doc.save()

        SOWTemplate = apps.get_model("document", "SOWTemplate")
        for template in SOWTemplate.objects.all():
            template.json_config.update(new_fields_templates)
            template.save()

    operations = [migrations.RunPython(add_new_fields_to_docs_and_templates)]
